//
//  TimeView.m
//  BuyDemo
//
//  Created by liuyanfang on 16/6/15.
//  Copyright © 2016年 ccc. All rights reserved.
//

#import "TimeView.h"
#define IS_DELEGATE_RSP_SEL(iDel, iSel) (iDel != nil && [iDel respondsToSelector:@selector(iSel)])
@implementation TimeView
{
    UILabel *timeLabel;
    NSString *nowTime;
    NSTimer *timeLimitTimer;
    long timeLimit;
}
- (id)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
        
        timeLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, frame.size.width, frame.size.height)];
        
        timeLabel.font = [UIFont systemFontOfSize:18];
        
        timeLabel.textAlignment = NSTextAlignmentCenter;
        
        timeLabel.textColor = [UIColor colorWithRed:255.0f/255.0f green:102.0f/255.0f blue:51.0f/255.0f alpha:1.0f];
        
        [self addSubview:timeLabel];
    }
    return self;
}
- (void)setFont:(CGFloat)font{
    timeLabel.font = [UIFont systemFontOfSize:font];
}
//set后台的时间戳 暂时写死
- (void)setTime:(NSString *)time{
    timeLimit = 360000;
    [self setUpTimer];
}
- (void)setUpTimer{
    [self invalidateTimer];

    timeLimitTimer = [NSTimer scheduledTimerWithTimeInterval:0.05f target:self selector:@selector(reloadTime) userInfo:nil repeats:YES];
    
    [[NSRunLoop currentRunLoop] addTimer:timeLimitTimer forMode:NSRunLoopCommonModes];
}
- (void)invalidateTimer{
    [timeLimitTimer invalidate];
    timeLimitTimer = nil;
}
- (void)reloadTime{
    
    timeLimit-=5;
    NSString *timeString = [NSString stringWithFormat:@"%ld",(long)timeLimit];
    timeLabel.text = [self showTimeWithTime:timeString];
    if (timeLimit<=0) {
        [self invalidateTimer];
        if (IS_DELEGATE_RSP_SEL(self.delegate, timeOverWithLocation:)) {
            [self.delegate timeOverWithLocation:_location];
        }
    }else{
        
    }
}
- (long)getTimeWithString:(NSString *)timeString{
    //JAVA的时间戳是毫秒
    NSDate* dat = [NSDate dateWithTimeIntervalSince1970:[timeString longLongValue]/1000.0];
    
    NSDate *date = [NSDate date];
    
    long a = [dat timeIntervalSinceDate:date];
    
    return a *100;

}
- (NSString *)showTimeWithTime:(NSString *)timeString{
    
    long timeNum = [timeString longLongValue];
    
    NSInteger ss = 100;
    
    NSInteger min = 60*ss;
    
    NSInteger minTime = timeNum/min;
    
    NSInteger ssTime =  (timeNum%min)/ss;
    
    NSInteger sssTime = timeNum%min%ss;
    
    NSString *minString = nil;
    
    NSString *ssSting = nil;
    
    NSString *sssString = nil;

    if (minTime<10) {
        minString = [NSString stringWithFormat:@"0%ld",(long)minTime];
    }else{
        minString = [NSString stringWithFormat:@"%ld",(long)minTime];
    }
    if (ssTime<10) {
        ssSting = [NSString stringWithFormat:@"0%ld",(long)ssTime];
    }else{
        ssSting = [NSString stringWithFormat:@"%ld",(long)ssTime];
    }
    
    if (sssTime<10) {
        sssString = [NSString stringWithFormat:@"0%ld",(long)sssTime];
    }else{
        sssString = [NSString stringWithFormat:@"%ld",(long)sssTime];
    }
    
    nowTime = [NSString stringWithFormat:@"%@:%@ %@",minString,ssSting,sssString];

    return nowTime;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
